L=80000; % 5000,10000,20000,40000,80000,160000

%Create model
md=model;

%Create mesh
nx=20; %number of nodes in x direction
ny=20;
md=squaremesh(model,L,L,nx,ny);

%Define mask
md=setmask(md,'',''); %ice sheet test

%Parameterize model
md=parameterize(md,'./ISMIPAback.par');

%Extrude to have a 3d model
md=extrude(md,5,1);

%Choose flow approximation
md=setflowequation(md,'pattyn','all');

%Create dirichlet on the bed only
md.diagnostic.spcvx=NaN*ones(md.mesh.numberofvertices,1);
md.diagnostic.spcvy=NaN*ones(md.mesh.numberofvertices,1);
md.diagnostic.spcvz=NaN*ones(md.mesh.numberofvertices,1);
pos=find(md.mesh.vertexonbed);
md.diagnostic.spcvx(pos)=0;
md.diagnostic.spcvy(pos)=0;
md.diagnostic.spcvz(pos)=0;

%Create MPCs to have periodic boundary conditions
posx=find(md.mesh.x==0);
posx2=find(md.mesh.x==max(md.mesh.x));
posy=find(md.mesh.y==0 & md.mesh.x~=0 & md.mesh.x~=max(md.mesh.x)); %Don't take the same grids two times
posy2=find(md.mesh.y==max(md.mesh.y) & md.mesh.x~=0 & md.mesh.x~=max(md.mesh.x));
md.diagnostic.vertex_pairing=[posx,posx2;posy,posy2];

%Set cluster and print messages
md.cluster=generic('name',oshostname(),'np',2);
md.verbose=verbose('convergence',true,'solution',true);

%Solve 
md=solve(md,DiagnosticSolutionEnum);
